/* Cube modelise par facettes                   */
/*                                              */
/* Auteur: Nicolas JANEY                        */
/* nicolas.janey@univ-fcomte.fr                 */
/* Fevrier 2023                                 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>

/* Variables et constantes globales             */
/* pour les angles et les couleurs utilises     */

static float rx = 0.0F;
static float ry = 0.0F;
static float rz = 0.0F;
static const float noir[] = { 0.0F,0.0F,0.0F,1.0F };
static const float blanc[] = { 1.0F,1.0F,1.0F,1.0F };
static const float gris[] = { 0.7F,0.7F,0.7F,1.0F };
static const float jaune[] = { 1.0F,1.0F,0.0F,1.0F };
static const float rouge[] = { 1.0F,0.0F,0.0F,1.0F };
static const float vert[] = { 0.0F,1.0F,0.0F,1.0F };
static const float bleu[] = { 0.0F,0.0F,1.0F,1.0F };
static int n = 36;

static int lighting = 1;
static int culling = 0;
static int polygonMode = 1;
static int normalize = 1;

/* Fonction d'initialisation des parametres     */
/* OpenGL ne changeant pas au cours de la vie   */
/* du programme                                 */

static void init(void) {
  const GLfloat shininess[] = { 50.0 };
  glMaterialfv(GL_FRONT,GL_AMBIENT,noir);
  glMaterialfv(GL_FRONT,GL_DIFFUSE,blanc);
  glMaterialfv(GL_FRONT,GL_SPECULAR,blanc);
  glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
  glLightfv(GL_LIGHT0,GL_DIFFUSE,rouge);
  glLightfv(GL_LIGHT1,GL_DIFFUSE,vert);
  glLightfv(GL_LIGHT2,GL_DIFFUSE,bleu);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHT1);
  glEnable(GL_LIGHT2);
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);
}

//////////////////////////////////////////////////

/* Scene dessinee                               */

static void face(float tx,float ty, int n,int m) {
  float dy = ty/m;
  float dx = tx/n;
  glPushMatrix();
  glNormal3f(0.0F,0.0F,1.0F);
  glTranslatef(-tx/2.0F,-ty/2.0F,0.0F);
  for ( int l = 0 ; l < m ; l++) {
    float yf = l * dy;
    float yi = yf + dy;
    float x = 0.0F;
    glBegin(GL_QUAD_STRIP);
    for ( int c = 0 ; c <= n ; c++ ) {
      glVertex2f(x,yi);
      glVertex2f(x,yf);
      x += dx; }
    glEnd(); }
  glPopMatrix();
}

static void mySolidCube(double ct,int n) {
  glPushMatrix();
  glPushMatrix();
  glTranslatef(0.0F,0.0F,ct/2.0F);
  face(ct,ct,n,n);
  glPopMatrix();
  glPushMatrix();
  glRotatef(90.0F,0.0F,1.0F,0.0f);
  glTranslatef(0.0F,0.0F,ct/2.0F);
  face(ct,ct,n,n);
  glPopMatrix();
  glPushMatrix();
  glRotatef(180.0F,0.0F,1.0F,0.0f);
  glTranslatef(0.0F,0.0F,ct/2.0F);
  face(ct,ct,n,n);
  glPopMatrix();
  glPushMatrix();
  glRotatef(270.0F,0.0F,1.0F,0.0f);
  glTranslatef(0.0F,0.0F,ct/2.0F);
  face(ct,ct,n,n);
  glPopMatrix();
  glPushMatrix();
  glRotatef(90.0F,1.0F,0.0F,0.0f);
  glTranslatef(0.0F,0.0F,ct/2.0F);
  face(ct,ct,n,n);
  glPopMatrix();
  glPushMatrix();
  glRotatef(-90.0F,1.0F,0.0F,0.0f);
  glTranslatef(0.0F,0.0F,ct/2.0F);
  face(ct,ct,n,n);
  glPopMatrix();
  glPopMatrix();
}

//////////////////////////////////////////////////

static void scene() {
  glPushMatrix();
  mySolidCube(2.5F,n);
  glPopMatrix();
}

/* Fonction executee lors d'un rafraichissement */
/* de la fenetre de dessin                      */

static void display(void) {
  glClearColor(0.75F,0.75F,0.75F,1.0F);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if ( lighting )
    glEnable(GL_LIGHTING);
    else
    glDisable(GL_LIGHTING);
  if ( culling )
    glEnable(GL_CULL_FACE);
    else
    glDisable(GL_CULL_FACE);
  glPolygonMode(GL_FRONT_AND_BACK,( polygonMode ) ? GL_FILL : GL_LINE);
  if ( normalize )
    glEnable(GL_NORMALIZE);
    else
    glDisable(GL_NORMALIZE);
  glPushMatrix();
  const GLfloat light0_pos[] = {  1.0F, 1.0F, 1.0F, 1.0F };
  const GLfloat light1_pos[] = { -1.0F, 0.0F, 1.0F, 1.0F };
  const GLfloat light2_pos[] = {  1.0F,-1.0F, 1.0F, 1.0F };
  glLightfv(GL_LIGHT0,GL_POSITION,light0_pos);
  glLightfv(GL_LIGHT1,GL_POSITION,light1_pos);
  glLightfv(GL_LIGHT2,GL_POSITION,light2_pos);
  glRotatef(rx,1.0F,0.0F,0.0F);
  glRotatef(ry,0.0F,1.0F,0.0F);
  glRotatef(rz,0.0F,0.0F,1.0F);
  glScalef(0.5F,0.5F,0.5F);
  scene();
  glPopMatrix();
  glFlush();
  glutSwapBuffers();
  int error = glGetError();
  if ( error != GL_NO_ERROR )
    printf("Erreur OpenGL: %d\n",error);
}

/* Fonction executee lorsqu'aucun evenement     */
/* n'est en file d'attente                      */

static void idle(void) {
  rx += 0.14256F ;
  ry += 0.16117F ;
  rz += 0.24174F ;
  glutPostRedisplay() ;
}

/* Fonction executee lors d'un changement       */
/* de la taille de la fenetre OpenGL            */

static void reshape(int x,int y) {
  glViewport(0,0,x,y);
  glMatrixMode(GL_PROJECTION) ;
  glLoadIdentity() ;
  gluPerspective(7.0F,(float) x/y,1.0,40.0) ;
  glMatrixMode(GL_MODELVIEW) ;
  glLoadIdentity() ;
  gluLookAt(0.0,0.0,20.0,0.0,0.0,0.0,0.0,1.0,0.0);
}

/* Fonction executee lors de l'appui            */
/* d'une touche alphanumerique du clavier       */

static void keyboard(unsigned char key,int x,int y) {
  switch (key) {
    case 'n' :
      n--;
      if ( n < 1 )
        n = 1;
      glutPostRedisplay();
      break;
    case 'N' :
      n++;
      glutPostRedisplay();
      break;
    case 'i' :
      lighting = !lighting;
      glutPostRedisplay();
      break;
    case 'c' :
      culling = !culling;
      glutPostRedisplay();
      break;
    case 'f' :
      polygonMode = !polygonMode;
      glutPostRedisplay();
      break;
    case 0x20 :
      normalize = !normalize;
      glutPostRedisplay();
      break;
    case 0x0D :
      { static int anim = 1;
        anim = !anim;
        glutIdleFunc(( anim ) ? idle : NULL); }
      break;
    case 0x1B :
      exit(0);
      break; }
}

/* Fonction executee lors de l'appui            */
/* d'une touche de curseur ou d'une touche      */
/* page up ou page down                         */

static void special(int key,int x,int y) {
  switch(key) {
    case GLUT_KEY_UP :
      rx++;
      glutPostRedisplay() ;
      break;
    case GLUT_KEY_DOWN :
      rx--;
      glutPostRedisplay() ;
      break;
    case GLUT_KEY_LEFT :
      ry++;
      glutPostRedisplay() ;
      break;
    case GLUT_KEY_RIGHT :
      ry--;
      glutPostRedisplay() ;
      break;
    case GLUT_KEY_PAGE_UP :
      rz++;
      glutPostRedisplay() ;
      break;
    case GLUT_KEY_PAGE_DOWN :
      rz--;
      glutPostRedisplay() ;
      break; }
}

/* Fonction principale                          */

int main(int argc,char **argv) {
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGBA|GLUT_DEPTH|GLUT_DOUBLE);
  glutInitWindowSize(300,300); 
  glutInitWindowPosition(50,50); 
  glutCreateWindow("Cube à faces facettisées"); 
  init();
  glutKeyboardFunc(keyboard);
  glutSpecialFunc(special);
  glutReshapeFunc(reshape);
  glutIdleFunc(idle);
  glutDisplayFunc(display);
  glutMainLoop();
  return(0);
}
